/*
***************************************************************************
**                                                                       **
**	Restart manager  -  Extension for Pale Moon                          **
**                                                                       **
**	Customization mode code                                              **
**                                                                       **
**	Copyright(C) 2018 by George Malamas                                  **
**                                                                       **
**	Free software for all people                                         **
**                                                                       **
**	Last edit: June 29, 2018                                             **
**                                                                       **
**	Release number: 2                                                    **
**                                                                       **
***************************************************************************
*/
/*
Since we set dynamically on our button some of its attributes, we have to do it also during customization.
Also, in appVer <4, we set always default class.
*/
// "use strict";
var cc = Components.classes;
var ci = Components.interfaces;
// var consoleServ = cc["@mozilla.org/consoleservice;1"].getService(ci.nsIConsoleService);
var winMed = cc["@mozilla.org/appshell/window-mediator;1"].getService(ci.nsIWindowMediator);
function setBtnAttributes() { // consoleServ.logStringMessage("setBtnAttributes");
	var mainBrowzerWin = winMed.getMostRecentWindow("navigator:browser");
	if(window.document.getElementById("CustomizeToolbarWindow")) {
		var rmToolbarBtn;
		var boldWidth = 0;
		function setBtnAttr() {window.setTimeout(function() { // console.log("function setBtnAttr");
			// consoleServ.logStringMessage("function setBtnAttr"); // appVer <4
			mainBrowzerWin._RestMan.onLoadStrings(); // Some of our prefs, used here, must be refreshed.
			if(rmToolbarBtn = mainBrowzerWin.document.getElementById("restman-button")) { // Button is in a toolbar.
				rmToolbarBtn.label = mainBrowzerWin._RestMan.restartLabel;
				rmToolbarBtn.setAttribute("tooltiptext", mainBrowzerWin._RestMan.restartLabel);
				rmToolbarBtn.setAttribute("iconStyle", mainBrowzerWin._RestMan.iconStyle);
				if(mainBrowzerWin._RestMan.invCachHghlght) {
					rmToolbarBtn.setAttribute("highlightBtn", true);
				};
				if(mainBrowzerWin._RestMan.appVer >=4) {
					if(mainBrowzerWin._RestMan.rmButtonStyle == 1 && rmToolbarBtn.getAttribute("class") !==
						"restman-toolbarbutton") {
						rmToolbarBtn.setAttribute("class", "restman-toolbarbutton");
					} else if(mainBrowzerWin._RestMan.rmButtonStyle == 0 && rmToolbarBtn.getAttribute("class") !==
						"toolbarbutton-1") {
						rmToolbarBtn.setAttribute("class", "toolbarbutton-1");
					};
					if(mainBrowzerWin._RestMan.rmSmallButton) {
						rmToolbarBtn.setAttribute("smallButton", true);
					};
					if(mainBrowzerWin._RestMan.appVer >=22) {
						rmToolbarBtn.setAttribute("appVer22-28", "");
					};
					if(mainBrowzerWin._RestMan.appVer >=14) {
						rmToolbarBtn.setAttribute("appVer14-28", "");
					};
					if(mainBrowzerWin._RestMan.appVer <14) {
						rmToolbarBtn.setAttribute("appVer4-13", "");
					};
					// We set the width of our button's label to be always as when the label is bold, to avoid the button to be
					// expanded/reduced when the label becomes bold/normal. This way, the extra space of label when it is normal
					// "absorbs" the extra width when it is bold.
					var hostToolbar = mainBrowzerWin.document.getElementById(rmToolbarBtn.parentNode.parentNode.parentNode.id);
					var toolbarMode = hostToolbar.getAttribute("mode");
					if(toolbarMode == "full" || toolbarMode == "text") { // console.log("toolbarMode: "+toolbarMode);
						if(!mainBrowzerWin._RestMan.invCachHghlght) {
							rmToolbarBtn.setAttribute("highlightBtn", true); // Makes the label "bold"
						};
						var btnLabel = rmToolbarBtn.ownerDocument.getAnonymousNodes(rmToolbarBtn)[1];
						if(btnLabel.getAttribute("class") == "toolbarbutton-text") { // Just for peace of mind..
							if(btnLabel.hasAttribute("style")) {
								btnLabel.removeAttribute("style"); // This is necessary on "customizationchange", if our button is in "Vertical Toolbar".
							}; // Otherwise, our button's label will take bigger width, if some other button with longer label is removed.
							// boldWidth = Math.round(parseInt(window.getComputedStyle(btnLabel).getPropertyValue("width")));
							boldWidth = btnLabel.clientWidth + 1; // Simpler/accurate than above, in all supported appVer.
							btnLabel.setAttribute("style", "width: "+boldWidth + "px;"+"");
						};
						if(!mainBrowzerWin._RestMan.invCachHghlght) {
							rmToolbarBtn.removeAttribute("highlightBtn");
						};
					} else {
						boldWidth = 0;
					};
				} else if(mainBrowzerWin._RestMan.appVer <4) {
					rmToolbarBtn.setAttribute("class", "toolbarbutton-1");
				};
				if(mainBrowzerWin._RestMan.appVer <4 && mainBrowzerWin.document.getElementById("wrapper-restman-toolbaritem")) { // Our "toolbarpaletteitem" just placed in a toolbar.
					// AppVer <4 don't have by default attribute "iconsize" in all toolbars, or it's not set (in additional toolbars),
					// until the user check for first time "Use Small Icons" in customization window.
					var itemInToolbar = mainBrowzerWin.document.getElementById("wrapper-restman-toolbaritem");
					if(itemInToolbar.parentNode.getAttribute("iconsize") == "") {
						itemInToolbar.setAttribute("hidden", true);
						window.updateIconSize(false); // customizeToolbar.js
						itemInToolbar.removeAttribute("hidden");
					};
				};
			} else if(rmToolbarBtn = window.document.getElementById("restman-button")) { // Button is in toolbar pallete.
				var rmToolbarpaletteitem = window.document.getElementById("wrapper-restman-toolbaritem");
				if(rmToolbarBtn.hasAttribute("highlightBtn")) {
					rmToolbarBtn.removeAttribute("highlightBtn");
				};
				if(mainBrowzerWin._RestMan.appVer >=4) {
					if(rmToolbarBtn.getAttribute("class") !=="restman-toolbarbutton") {
						rmToolbarBtn.setAttribute("class", "restman-toolbarbutton");
					};
					rmToolbarpaletteitem.setAttribute("title", mainBrowzerWin._RestMan.restartLabel);
					rmToolbarpaletteitem.setAttribute("tooltiptext", mainBrowzerWin._RestMan.restartTitle);
				} else if(mainBrowzerWin._RestMan.appVer <4) {
					rmToolbarBtn.setAttribute("class", "toolbarbutton-1");
					rmToolbarBtn.label = mainBrowzerWin._RestMan.restartLabel;
					rmToolbarBtn.setAttribute("tooltiptext", mainBrowzerWin._RestMan.restartLabel);
				};
			};
		}, 0);}
		function setBtnAttr2() {window.setTimeout(function() { // AppVer 1.5 - 3.6
			// consoleServ.logStringMessage("function setBtnAttr2");
			var rmToolbarBtnInPalette;
			if(rmToolbarBtnInPalette = window.document.getElementById("restman-button")) { // Button is in toolbar pallete.
				rmToolbarBtnInPalette.label = mainBrowzerWin._RestMan.restartLabel;
				rmToolbarBtnInPalette.setAttribute("tooltiptext", mainBrowzerWin._RestMan.restartLabel);
				rmToolbarBtnInPalette.setAttribute("class", "toolbarbutton-1");
				if(rmToolbarBtnInPalette.hasAttribute("highlightBtn")) {
					rmToolbarBtnInPalette.removeAttribute("highlightBtn");
				};
			};
		}, 0);}
		if((window.document.getElementById("restman-button"))
			|| (mainBrowzerWin.document.getElementById("restman-button"))) {
			if(mainBrowzerWin._RestMan.appVer >=4) {
				mainBrowzerWin.addEventListener("customizationchange", setBtnAttr, false); // AppVer >=4.
			};
			if(mainBrowzerWin._RestMan.appVer <4 && mainBrowzerWin._RestMan.appVer >=3.5) { // AppVer 3.5 & 3.6.
				mainBrowzerWin.addEventListener("drop", setBtnAttr, true);
				window.addEventListener("drop", setBtnAttr2, true);
			};
			if(mainBrowzerWin._RestMan.appVer <3.5) { // AppVer 1.5 - 3.
				mainBrowzerWin.addEventListener("dragdrop", setBtnAttr, true);
				window.addEventListener("dragdrop", setBtnAttr2, true);
			};
		};
		window.addEventListener("unload", function () {
			if(mainBrowzerWin._RestMan.appVer >=4) {
				mainBrowzerWin.removeEventListener("customizationchange", setBtnAttr, false); // AppVer >=4.
				// console.log("boldWidth: " + boldWidth);
				if(boldWidth >0) { // Toolbar mode = "full" or "text".
					rmToolbarBtn.ownerDocument.getAnonymousNodes(rmToolbarBtn)[1].setAttribute("style", "width: "+boldWidth + "px;"+"");
				};
			};
			if(mainBrowzerWin._RestMan.appVer <4 && mainBrowzerWin._RestMan.appVer >=3.5) { // AppVer 3.5 & 3.6.
				mainBrowzerWin.removeEventListener("drop", setBtnAttr, true);
			};
			if(mainBrowzerWin._RestMan.appVer <3.5) { // AppVer 1.5 - 3.
				mainBrowzerWin.removeEventListener("dragdrop", setBtnAttr, true);
			};
		}, false);
		setBtnAttr();
	};
};

